# -*- coding: utf-8 -*-
from flask import Flask, request
from mysql.connector import connect, Error
import configparser
import json

app = Flask(__name__)

#Читаем файл config.ini для дальнейшего использования в коде
config = configparser.ConfigParser()
config.read("config.ini", encoding='utf-8')

#Запрашиваем необходимые нам строки из config.ini
dbHost = config["db"]["host"]
dbUser = config["db"]["user"]
dbPass = config["db"]["pass"]
dbName = config["db"]["dbname"]

#Если POST запрос был отправлен на адрес /, то в таком случае начинает работать функция webhook
@app.route('/', methods=['POST'])
def webhook():
	try:
		with connect(host=dbHost,user=dbUser,password=dbPass,database=dbName) as connection:
			#Сначала мы получаем тело запроса - request.json, далее его преобразуем в json
			#После этого переводим его в строку (str), чтобы можно было корректно отправить запрос в бд
			sqlQuery = str(json.dumps(request.json))
			#Кодируем все символы в UTF-8, чтобы не возникло проблем с запросом к бд
			sqlQuery = sqlQuery.encode().decode('unicode_escape')
			
			#Сам запрос к бд
			#На самом деле его можно сократить до "INSERT INTO `zenno` (`json`) VALUES ('" + sqlQuery + "')"
			#Так как наша таблица автоматически ставит и id, и status
			createDbQuery = "INSERT INTO `zenno` (`id`, `json`, `status`) VALUES (NULL, '" + sqlQuery + "', 0)"
			#Дополнительный запрос без которого не происходило сохранение данных строкой выше
			commitQuery = "COMMIT"
			with connection.cursor() as cursor:
				#Отправляем запросы
				cursor.execute(createDbQuery)
				cursor.execute(commitQuery)
				
	except Error as e:
		print(e)
	
	return 'ok'

#Запускаем сервер на порте 8081
app.run(host='0.0.0.0', port=8081)